#!/usr/bin/perl
# indexsoft intuitive mailer
# http://www.indexsoft.com

$|++;
&ReadArgv();

if ($FORK)
{
	$pid = fork();
	if (!defined $pid) { print "can not fork: $!.\n"; exit; }
	elsif ($pid) { exit; } #forked successfully. PID: $pid
}

if ($QUIET) { close STDIN; close STDOUT; open(STDERR, ">&STDOUT"); }

$ENV{'WINDIR'}?($DirSeparator = '\\'):($DirSeparator = '/');
$configfile = $0;
$configfile =~ s/(delivery.cgi|delive~1.cgi)$//gi;
chop $configfile;
$configfile = '.' if !$configfile;
push (@INC, $configfile);
$configfile = "$configfile$DirSeparator".'intuitive.pm';
require "$configfile";

use DBI;
$SIG{__WARN__} = PrintError;
$MLDBH = DBI->connect("DBI:mysql:database=$mySQLDBName;host=$mySQLHost",$mySQLUser,$mySQLPassword);
$sth = $MLDBH->prepare("select pname, pvalue from _iml_tune");
$sth -> execute();
${$pname} = $pvalue while (($pname, $pvalue) = $sth->fetchrow_array());

use sendmail;
$sm = new SendMail($SMTP, $SMTPPort);
$sm->setDebug($sm->OFF);

if ($POP3Auth)
{
	eval('use Mail::POP3Client;');
	die("$@\n") if $@;
	($pop3login,$pop3password) = split(/:/, $POP3Auth);
	$pop = new Mail::POP3Client(HOST=>"$SMTP", AUTH_MODE=>"PASS", DEBUG=>'0');
	$pop->User("$pop3login");
	$pop->Pass("$pop3password");
	$pop->Connect();
	$pop->Message() =~ /^\+OK/i || die('POP auth: '.$pop->Message()."\n");
	$pop->Close();
}

if (-e $PIDFile)
{
	unless (open(PIDFILE,$PIDFile)) { die("can not open PID file.\n") }
	$pid = <PIDFILE>; close PIDFILE;
	if ($oldpid > 1 && kill(0,$oldpid)) { die("process with PID $pid is already running.\n") }
	else { print "process with PID $pid is long dead.\n" }
}
open (PID, ">$PIDFile") or die("can not create PID file.\n"); print PID $$; close(PID);

my ($emptyfile) = 'Attachment disabled at shareware version. Please register indexsoft intuitive mailer.';
$statement = "select did, dname, dispatch from _iml_dispatches where did in ($DID)";
$statement = "select did, dname, dispatch from _iml_dispatches" if !$DID;
$sth = $MLDBH->prepare($statement);
$sth -> execute();
while(($did, $dname, $dispatch) = $sth->fetchrow_array())
{
	print "\nstart dispatch: $dname\n";
	foreach $line(split(/\255/, $dispatch)) { ($param, $value) = split(/\254/, $line); ${$param} = $value; }
	$BODY .= "\n------\nsend by indexsoft intuitive mailer shareware (http://www.indexsoft.com)";
	$BODY =~ s/\n/\r\n/g;
	$STATEMENT = "select distinct uname, uemail from _iml_users, _iml_members where muid = uid and mmid in ($MID) and uact = '1'" if (!$STATEMENT);
	$sth2 = $MLDBH->prepare($STATEMENT);
	$sth2 -> execute();
	$found = $sth2->rows();
	print "send messages to $found subscribers\n";
	while (($uname, $uemail) = $sth2->fetchrow_array())
	{
		my ($BODY, $SUBJECT) = ($BODY, $SUBJECT);
		$BODY =~ s/%name%/$uname/g; $BODY =~ s/%email%/$uemail/g;
		$SUBJECT =~ s/%name%/$uname/g;		$SUBJECT =~ s/%email%/$uemail/g;
		$sm->From($FROMEMAIL);		$sm->Subject("$SUBJECT");		$sm->To("$uname <$uemail>");
		$sm->setMailHeader('X-Mailer', 'indexsoft intuitive mailer (http://www.indexsoft.com)');
		grep($sm->setMailHeader(split(/: */, $_)), split(/\0/, $MAILHEADERS));
		$HTML?($sm->Inline('message.htm', \$BODY)):($sm->setMailBody("$BODY"));
		grep(do{$sm->Attach("$_.txt", \$emptyfile) if (-e $_)}, split(/\0/, $FILES));
		if ($sm->sendMail() != 0) { print "$uemail: ".$sm->{'error'}."\n" }
		$sm->reset();
	}
	$MLDBH -> do("delete from _iml_dispatches where did = $did") if $DEL;
}

unlink $PIDFile;
print "\ndone.\n";

#########################
sub ReadArgv
{
	($DID, $DEL, $QUIET) = ();
	my ($line) = ();
	foreach $line(@ARGV)
	{
		# --d=1(2...)
		if ($line =~ '^--d=(\d+)$') { $DID?($DID .= ",$1"):($DID = $1); }
		# --del
		elsif ($line =~ '^--del$') { $DEL = 1; }
		# --mail
		elsif ($line =~ '^--quiet$') { $QUIET = 1; }
		# --fork
		elsif ($line =~ '^--fork$') { $FORK = 1; }
	}
}

sub PrintError
{
	print "$_[0]\n";
}

